Loading...
Searching...
No Matches
LeafData< ValueOnIndexMask, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

Inheritance diagram for LeafData< ValueOnIndexMask, CoordT, MaskT, LOG2DIM >:

## Public Types

using | BuildType = ValueOnIndexMask
using | ValueType
using | FloatType
using | ArrayType
using | BaseT = LeafIndexBase<CoordT, MaskT, LOG2DIM>

## Public Member Functions

bool | isMaskOn (uint32_t offset) const
void | setMask (uint32_t offset, bool v)
ValueType | getValue (uint32_t i) const
void | setValueOnly (uint32_t offset, const ValueType &value)
void | setValue (uint32_t offset, const ValueType &value)
void | setOn (uint32_t offset)
ValueType | getMin () const
ValueType | getMax () const
FloatType | getAvg () const
FloatType | getDev () const
void | setMin (const ValueType &v)
void | setMax (const ValueType &v)
void | setAvg (const FloatType &v)
void | setDev (const FloatType &v)
void | setOrigin (const T &ijk)
void | fill (const ValueType &v)
| LeafData ()=delete
| This class cannot be constructed or deleted.
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
uint32_t | valueCount () const
uint64_t | lastOffset () const
bool | hasStats () const
void | setValueOnly (uint32_t offset, const ValueType &value)
void | setValue (uint32_t offset, const ValueType &value)
void | setMin (const ValueType &v)
void | setMin (const ValueType &)
void | setMax (const ValueType &v)
void | setMax (const ValueType &)
void | setAvg (const FloatType &)
void | setDev (const FloatType &)
void | fill (const ValueType &v)
const uint64_t & | firstOffset () const

## Static Public Member Functions

static uint64_t | memUsage ()
static constexpr uint32_t | padding ()
| Return padding of this class in bytes, due to aliasing and 32B alignment.
static bool | hasStats ()

## Public Attributes

MaskT< LOG2DIM > | mMask
CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
ValueType | mMinimum
ValueType | mMaximum
FloatType | mAverage
FloatType | mStdDevi
ValueType | mValues [1u<< 3 *LOG2DIM]
uint64_t | mOffset
uint64_t | mPrefixSum

## Static Public Attributes

static constexpr bool | FIXED_SIZE

## Member Typedef Documentation

## ArrayType

using ArrayType

## BaseT

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BaseT = LeafIndexBase<CoordT, MaskT, LOG2DIM>

inherited

## BuildType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = ValueOnIndexMask

## FloatType

using FloatType

## ValueType

using ValueType

## Constructor & Destructor Documentation

## LeafData()

LeafData | ( |  | ) |

delete

This class cannot be constructed or deleted.

## ~LeafData()

~LeafData | ( |  | ) |

delete

## Member Function Documentation

## fill() [1/2]

void fill | ( | const ValueType & | v | ) |

inlineinherited

## fill() [2/2]

void fill | ( | const ValueType & | v | ) |

inline

## firstOffset()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

const uint64_t & firstOffset | ( |  | ) | const

inlineinherited

## getAvg()

FloatType getAvg | ( |  | ) | const

inline

## getDev()

FloatType getDev | ( |  | ) | const

inline

## getMax()

ValueType getMax | ( |  | ) | const

inline

## getMin()

ValueType getMin | ( |  | ) | const

inline

## getValue()

ValueType getValue | ( | uint32_t | i | ) | const

inline

## hasStats() [1/2]

bool hasStats | ( |  | ) |

inlinestatic

## hasStats() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool hasStats | ( |  | ) | const

inlineinherited

## isMaskOn()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool isMaskOn | ( | uint32_t | offset | ) | const

inline

## lastOffset()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t lastOffset | ( |  | ) | const

inlineinherited

## memUsage()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t memUsage | ( |  | ) |

inlinestatic

## operator=()

LeafData & operator= | ( | const LeafData< ValueOnIndexMask, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## padding()

constexpr uint32_t padding | ( |  | ) |

inlinestaticconstexpr

Return padding of this class in bytes, due to aliasing and 32B alignment.

Note
  The extra bytes are not necessarily at the end, but can come from aliasing of individual data members.

## setAvg() [1/2]

void setAvg | ( | const FloatType & | v | ) |

inline

## setAvg() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | const FloatType & |  | ) |

inlineinherited

## setDev() [1/2]

void setDev | ( | const FloatType & | v | ) |

inline

## setDev() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | const FloatType & |  | ) |

inlineinherited

## setMask()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMask | ( | uint32_t | offset,
|  | bool | v )

inline

## setMax() [1/3]

void setMax | ( | const ValueType & | v | ) |

inlineinherited

## setMax() [2/3]

void setMax | ( | const ValueType & | v | ) |

inline

## setMax() [3/3]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | const ValueType & |  | ) |

inlineinherited

## setMin() [1/3]

void setMin | ( | const ValueType & | v | ) |

inlineinherited

## setMin() [2/3]

void setMin | ( | const ValueType & | v | ) |

inline

## setMin() [3/3]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | const ValueType & |  | ) |

inlineinherited

## setOn()

void setOn | ( | uint32_t | offset | ) |

inline

## setOrigin()

void setOrigin | ( | const T & | ijk | ) |

inline

## setValue() [1/2]

void setValue | ( | uint32_t | offset,
|  | const ValueType & | value )

inlineinherited

## setValue() [2/2]

void setValue | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## setValueOnly() [1/2]

void setValueOnly | ( | uint32_t | offset,
|  | const ValueType & | value )

inlineinherited

## setValueOnly() [2/2]

void setValueOnly | ( | uint32_t | offset,
|  | const ValueType & | value )

inline

## valueCount()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint32_t valueCount | ( |  | ) | const

inlineinherited

## Member Data Documentation

## FIXED_SIZE

bool FIXED_SIZE

staticconstexpr

## mAverage

FloatType mAverage

## mBBoxDif

uint8_t mBBoxDif[3]

## mBBoxMin

CoordT mBBoxMin

## mFlags

uint8_t mFlags

## mMask

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

MaskT<LOG2DIM> mMask

## mMaximum

ValueType mMaximum

## mMinimum

ValueType mMinimum

## mOffset

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mOffset

inherited

## mPrefixSum

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mPrefixSum

inherited

## mStdDevi

FloatType mStdDevi

## mValueMask

MaskT<LOG2DIM> mValueMask

## mValues

ValueType mValues[1u<< 3 *LOG2DIM]